//+------------------------------------------------------------------+ 
//|                                                !OnChartEvent.mqh |
//+------------------------------------------------------------------+ 
// Current value on the panel or
// the value entered in the input box
string currVal="";
bool flgDialogWin=false; // Flag for panel existence
int
szArrList=0,// Size of the option list array
number=-1; // Parameter number in the panel list
string
nmMsgBx="",  // Name of the dialog window
nmValObj=""; // Name of the selected object
//---
// Option list arrays in the dialog window
string lenum[],lenmObj[];
//---
// Colors of the dialog window elements
color
clrBrdBtn=clrWhite,
clrBrdFonMsg=clrDimGray,clrFonMsg=C'15,15,15',
clrChoice=clrWhiteSmoke,clrHdrBtn=clrBlack,
clrFonHdrBtn=clrGainsboro,clrFonStr=C'22,39,38';
//+------------------------------------------------------------------+ 
//| USER EVENTS                                                      |
//+------------------------------------------------------------------+ 
void OnChartEvent(const int     id,
                  const long   &lparam,
                  const double &dparam,
                  const string &sparam)
  {
// If the event is real time and the "On The Fly" setting mode is enabled
   if(NotTest() && SettingOnTheFly)
     {
      //+------------------------------------------------------------------+ 
      //| THE CHARTEVENT_OBJECT_CLICK EVENT                                |
      //+------------------------------------------------------------------+ 
      if(ChartEvent_ObjectClick(id,lparam,dparam,sparam)) { return; }
      //---
      //+------------------------------------------------------------------+ 
      //| THE CHARTEVENT_OBJECT_ENDEDIT EVENT                              |
      //+------------------------------------------------------------------+ 
      if(ChartEvent_ObjectEndEdit(id,lparam,dparam,sparam)) { return; }
     }
//---
   return;
  }
//+------------------------------------------------------------------+ 
//| THE CHARTEVENT_OBJECT_CLICK EVENT                                |
//+------------------------------------------------------------------+ 
bool ChartEvent_ObjectClick(int id,long lparam,double dparam,string sparam)
  {
   // If there was an event of clicking on a graphical object
   if(id==CHARTEVENT_OBJECT_CLICK) // id==1
     {
      Get_STV(); // Get all data on the symbol
      //---
      string clickedChartObject=sparam; // Name of the clicked object
      //---
      // Get the chart size
      width_chart=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,0);
      height_chart=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,0);
      //---
      DialogWindowInfoPanel(clickedChartObject);
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+ 
//| CHARTEVENT_OBJECTS_ENDEDIT                                       |
//+------------------------------------------------------------------+ 
bool ChartEvent_ObjectEndEdit(int id,long lparam,double dparam,string sparam)
  {
   if(id==CHARTEVENT_OBJECT_ENDEDIT) // id==3
     {
      string editObject=sparam; // Name of the edited object
      //---
      // If the value has been entered in the input box in the dialog window
      if(editObject=="editValIP")
        {
         // Get the entered value
         currVal=ObjectGetString(0,"editValIP",OBJPROP_TEXT);
         //---
         // (0) Period Indicator
         if(number==0)
           {
            // Correct the value if it is wrong
            if(currVal=="0" || currVal=="" || SD(currVal)<=0) { currVal="1"; }
            //---
            // Set the entered value
            ObjectSetString(0,"enumMB0",OBJPROP_TEXT,currVal);
           }
         //---
         // (4) Lot
         if(number==4)
           {
            // Correct the value if it is wrong
            if(currVal=="0" || currVal=="" || SD(currVal)<=0) { currVal=DS(SS.vol_min,2); }
            //---
            // Set the entered value
            ObjectSetString(0,"enumMB0",OBJPROP_TEXT,DS2(SD(currVal)));
           }
         //---
         // (1) Take Profit (p)
         // (2) Stop Loss (p)
         if(number==1 || number==2)
           {
            // Correct the value if it is wrong
            if(currVal=="0" || currVal=="" || SD(currVal)<=0) { currVal="1"; }
            //---
            // Set the entered value
            ObjectSetString(0,"enumMB1",OBJPROP_TEXT,currVal);
           }
         //---         
         DelObjbyName("editValIP"); ChartRedraw();
        }
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+ 
//| DIALOG WINDOW OF THE INFO PANEL                                  |
//+------------------------------------------------------------------+ 
void DialogWindowInfoPanel(string clickObj)
  {
// If there is currently no dialog window
   if(!flgDialogWin)
     {
      // Get the object number in the array
      // Exit if none of the parameters displayed on the panel has been clicked
      if((number=GetNumberClickedObjIP(clickObj))==-1) { return; }
      //---
      // Initialization of default values
      // and determination of the list array size
      if(!InitArraysAndDefault()) { return; }
      //---
      // Set the dialog window
      SetDialogWindow();
      //---
      flgDialogWin=true; // Mark the dialog window as open
      ChartRedraw();
     }
   else // If the dialog window is open
     {
      // Set the input box for the modification of the value
      SetEditObjInDialogWindow(clickObj);
      //---
      // If one of the buttons in the dialog box is clicked
      if(clickObj=="btnApply" || clickObj=="btnCancel")
        {
         // If the Apply button is clicked
         if(clickObj=="btnApply")
           {
            // Compare values on the panel with the ones on the list
            // If the value on the list is different from the one that is currently displayed on the panel (which means it is different from the one in the file),
            // ...change the value on the panel and update the file
            if(currVal!=ObjectGetString(0,nmValObj,OBJPROP_TEXT))
              {
               // Update the value on the panel
               ObjectSetString(0,nmValObj,OBJPROP_TEXT,currVal); ChartRedraw();
               //---
               // Read all data on the panel and write it to the file
               WriteNewData();
              }
           }
         //---
         DelDialogWindow(lenmObj); // Delete the dialog window
         iZeroMemory(); // Zero out the variables
         //---
         // Update the data
         SetParameters();
         GetHandlesIndicators();
         SetInfoPanel();
         //---
         ChartRedraw();
        }
      else // If neither Apply nor Cancel has been clicked
        {
         // Selection of the dialog window list option
         SelectionOptionInDialogWindow(clickObj);
         //---
         ChartRedraw();
        }
     }
  }
//+------------------------------------------------------------------+ 
//| DETERMINING THE ELEMENT NUMBER FROM THE ARRAY OF OBJECTS OF THE INFO PANEL            |
//+------------------------------------------------------------------+ 
int GetNumberClickedObjIP(string clckObj)
  {
   int n=-1;
//---
   for(int i=0; i<szArrIP; i++)
     {
      if(clckObj==arr_objip[i][1] || clckObj==arr_objip[i][2]) { n=i; break; }
     }
//---
   return(n);
  }  
//+------------------------------------------------------------------+ 
//| INITIALIZATION OF DEFAULT VALUES                                 |
//+------------------------------------------------------------------+ 
bool InitArraysAndDefault()
  {
// (0) Period Indicator
// (4) Lot
   if(number==0 || number==4)
     {
      ArrayResize(lenum,1);
      ArrayResize(lenmObj,1);
      lenum[0]="";
      //---
      nmMsgBx=arr_objip[number][0]; // Header text
      nmValObj=arr_objip[number][2]; // Name of the object of values
      currVal=ObjectGetString(0,nmValObj,OBJPROP_TEXT); // Current value on the panel
      //---
      if(currVal=="0" || currVal=="")
        {
         // Determine default values
         switch(number)
           {
            case 0 : lenum[0]="10";  break; // Period Indicator
            case 4 : lenum[0]="0.1"; break; // Lot
           }
        }
      else { lenum[0]=currVal; }
      return(true);
     }
//---
// (1) Take Profit (p)
// (2) Stop Loss (p)
   if(number==1 || number==2)
     {
      ArrayResize(lenum,2);
      ArrayResize(lenmObj,2);
      lenum[0]="FALSE";
      lenum[1]="";
      //---
      nmMsgBx=arr_objip[number][0]; // Header text
      nmValObj=arr_objip[number][2]; // Name of the object of values
      currVal=ObjectGetString(0,nmValObj,OBJPROP_TEXT); // Current value on the panel
      //---
      if(currVal=="" || currVal=="FALSE")
        {
         // Determine default values
         switch(number)
           {
            case 1 : lenum[1]="50"; break; // Take Profit (p)
            case 2 : lenum[1]="10"; break; // Stop Loss (p)
           }
        }
      else { lenum[1]=currVal; }
      return(true);
     }
//---
// (3) Reverse
   if(number==3)
     {
      ArrayResize(lenum,2);
      ArrayResize(lenmObj,2);
      lenum[0]="FALSE";
      lenum[1]="TRUE";
      //---
      nmMsgBx=arr_objip[number][0]; // Header text
      nmValObj=arr_objip[number][2]; // Name of the object of values
      currVal=ObjectGetString(0,nmValObj,OBJPROP_TEXT); // Current value on the panel
      return(true);
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+ 
//| SETTING THE DIALOG WINDOW                                        |
//+------------------------------------------------------------------+ 
void SetDialogWindow()
  {
   int
   fln=16, // First line
   hln=12; // Line height
   int
   corner=CORNER_LEFT_UPPER,
   anchor=ANCHOR_RIGHT_UPPER;
//---
   int
   fonW=200,fonH=100;
//---
   int
   FnHdrX=(width_chart/2)-(fonW/2),
   FnHdrY=(height_chart/2)-(fonH/2),
   applX=(width_chart/2)-(fonW/2)+85,
   cnclX=(width_chart/2)-(fonW/2)+140,
   chcX=width_chart/2+90,
   btnsY=FnHdrY+fonH-25;
//---
   CreateEdit(0,0,"FonMsgBox","",corner,"Arial",8,clrBrdFonMsg,fonW,fonH,FnHdrX,FnHdrY,2,clrFonMsg,1);
   CreateEdit(0,0,"HeaderMsgBox",nmMsgBx,corner,bsc_fnt,8,clrHdrBtn,fonW,16,FnHdrX,FnHdrY,3,clrFonHdrBtn,1);
//---
   CreateButton(0,0,"btnApply","Apply",anchor,corner,bsc_fnt,font_sz,clrHdrBtn,clrFonHdrBtn,clrBrdBtn,50,16,applX,btnsY,3);
   CreateButton(0,0,"btnCancel","Cancel",anchor,corner,bsc_fnt,font_sz,clrHdrBtn,clrFonHdrBtn,clrBrdBtn,50,16,cnclX,btnsY,3);
//---
   szArrList=ArraySize(lenum); // Get the (option list) array size
//---
   int Y=0;
// Set the current value substrate
   for(int i=0; i<szArrList; i++)
     {
      if(i==0) { Y=FnHdrY+fln; } else { Y=FnHdrY+fln+hln*i; }
      //---
      if(currVal==lenum[i])
        { CreateEdit(0,0,"fonStrings","",corner,bsc_fnt,8,clrFonStr,fonW-2,13,FnHdrX+1,Y,3,clrFonStr,1); }
     }
//---
// Set the list of all values
   for(int i=0; i<szArrList; i++)
     {
      lenmObj[i]="enumMB"+IS(i);
      //---
      if(i==0) { Y=FnHdrY+fln; } else { Y=FnHdrY+fln+hln*i; }
      //---
      CreateLabel(0,0,lenmObj[i],lenum[i],anchor,corner,bsc_fnt,font_sz,clrChoice,chcX,Y,4);
     }
  }
//+------------------------------------------------------------------+ 
//| SELECTING AN OPTION IN THE DIALOG WINDOW                         |
//+------------------------------------------------------------------+ 
void SelectionOptionInDialogWindow(string clickObj)
  {
   int corner=CORNER_LEFT_UPPER;
//---
   int
   fln=16, // First line
   hln=12, // Line height
   fonW=200,fonH=100,
   FnHdrX=(width_chart/2)-(fonW/2),
   FnHdrY=(height_chart/2)-(fonH/2);
//---
   string mbname=ObjectGetString(0,clickObj,OBJPROP_NAME); // Get the name of the clicked object
   string mbcurrVal=ObjectGetString(0,clickObj,OBJPROP_TEXT); // Get the text of the clicked object
//---
// If the clicked object value is different from the one
// that was previously registered
   if(mbcurrVal!=currVal && 
      StringFind(mbname,"enumMB",0)>=0)
     {
      DelObjbyName("editValIP"); // Delete the input box, if available
      //---
      currVal=mbcurrVal; // Store the value of the clicked object
      //---
      // Move the option selection object in the list
      int Y=0;
      for(int i=0; i<szArrList; i++)
        {
         if(i==0) { Y=FnHdrY+fln; } else { Y=FnHdrY+fln+hln*i; }
         //---
         if(currVal==lenum[i])
           { CreateEdit(0,0,"fonStrings","",corner,bsc_fnt,8,clrFonStr,fonW-2,13,FnHdrX+1,Y,3,clrFonStr,1); return; }
        }
     }
  }
//+------------------------------------------------------------------+ 
//| EDITING VALUES IN THE DIALOG WINDOW                              |
//+------------------------------------------------------------------+ 
void SetEditObjInDialogWindow(string clickObj)
  {
   int corner=CORNER_RIGHT_UPPER;
//---
   int
   fln=16, // First line
   hln=12, // Line height   
   fonH=100, // Height of the dialog window
   FnHdrY=(height_chart/2)-(fonH/2);
//---
// If edit-object 1 is clicked
   if(clickObj=="enumMB0")
     {
      // (0) Period Indicator
      // (4) Lot
      if(number==0 || number==4)
        {
         string nmClkObj=ObjectGetString(0,"enumMB0",OBJPROP_TEXT);
         CreateEdit(0,0,"editValIP",nmClkObj,corner,bsc_fnt,8,clrWhiteSmoke,50,13,width_chart/2-41,FnHdrY+fln,5,clrBlack,0);
         return;
        }
     }
//---
// If edit-object 2 is clicked
   if(clickObj=="enumMB1")
     {
      // (1) Take Profit (p)
      // (2) Stop Loss (p)
      if(number==1 || number==2)
        {
         string nmClkObj=ObjectGetString(0,"enumMB1",OBJPROP_TEXT);
         CreateEdit(0,0,"editValIP",nmClkObj,corner,bsc_fnt,8,clrWhiteSmoke,50,13,width_chart/2-41,FnHdrY+fln+hln,5,clrBlack,0);
         return;
        }
     }
  }
//+------------------------------------------------------------------+ 
//| DELETING THE DIALOG WINDOW                                       |
//+------------------------------------------------------------------+ 
void DelDialogWindow(string &arrObj[])
  {
   Sleep(100);
   DelObjbyName("FonMsgBox");
   DelObjbyName("HeaderMsgBox");
//---
   int szArr=ArraySize(arrObj);
   for(int i=0; i<szArr; i++)
     { DelObjbyName(arrObj[i]); }
//---
   DelObjbyName("btnApply");
   DelObjbyName("btnCancel");
   DelObjbyName("fonStrings");
   DelObjbyName("editValIP");
  }
//+------------------------------------------------------------------+ 
//| FORMATTING A STRING VALUE FROM THE INFO PANEL                    |
//+------------------------------------------------------------------+ 
string FormatStringFromIP(string val_ip)
  {
   if(val_ip=="TRUE") { return("1"); }
   if(val_ip=="FALSE") { return("0"); }
//---
   return(val_ip);
  }
//+------------------------------------------------------------------+ 
