//+------------------------------------------------------------------+ 
//|                                                ADD_FUNCTIONS.mqh |
//+------------------------------------------------------------------+ 
//+------------------------------------------------------------------+ 
//| CONVERTING FROM DATETIME TO STRING IN THE TIME_DATE FORMAT       |
//+------------------------------------------------------------------+ 
string TSd(datetime aValue)
  {
   return(TimeToString(aValue,TIME_DATE));
  }
//+------------------------------------------------------------------+ 
//| CONVERTING FROM DATETIME TO STRING IN THE TIME_MINUTES FORMAT    |
//+------------------------------------------------------------------+ 
string TSm(datetime aValue)
  {
   return(TimeToString(aValue,TIME_MINUTES));
  }
//+------------------------------------------------------------------+ 
//| CONVERTING FROM DATETIME TO STRING IN THE                        |
//| TIME_MINUTES|TIME_SECONDS FORMAT                                 |
//+------------------------------------------------------------------+ 
string TSms(datetime aValue)
  {
   return(TimeToString(aValue,TIME_MINUTES|TIME_SECONDS));
  }
//+------------------------------------------------------------------+ 
//| CONVERTING FROM DATETIME TO STRING                               |
//| IN THE TIME_DATE|TIME_MINUTES FORMAT                             |
//+------------------------------------------------------------------+ 
string TSdm(datetime aValue)
  {
   return(TimeToString(aValue,TIME_DATE|TIME_MINUTES));
  }
//+------------------------------------------------------------------+ 
//| CONVERTING FROM DATETIME TO STRING                               |
//| IN THE TIME_DATE|TIME_MINUTES|TIME_SECONDS FORMAT                |
//+------------------------------------------------------------------+ 
string TSdms(datetime aValue)
  {
   return(TimeToString(aValue,TIME_DATE|TIME_MINUTES|TIME_SECONDS));
  }
//+------------------------------------------------------------------+ 
//| CONVERTING FROM INTEGER TO STRING                                |
//+------------------------------------------------------------------+ 
string IS(int aValue)
  {
   return(IntegerToString(aValue));
  }
//+------------------------------------------------------------------+ 
//| CONVERTING FROM DOUBLE TO STRING                                 |
//+------------------------------------------------------------------+ 
string DS(double aValue,int amount)
  {
   return(DoubleToString(aValue,amount));
  }
//+------------------------------------------------------------------+ 
//| CONVERTING FROM DOUBLE TO STRING WITH TWO DIGITS                 |
//+------------------------------------------------------------------+ 
string DS2(double aValue)
  {
   return(DoubleToString(aValue,2));
  }
//+------------------------------------------------------------------+ 
//| CONVERTING FROM DOUBLE TO STRING WITH THE NUMBER OF DIGITS EQUAL TO "DIGITS"                  |
//+------------------------------------------------------------------+ 
string DS_dgt(double aValue,int digit)
  {
   return(DoubleToString(aValue,digit));
  }
//+------------------------------------------------------------------+ 
//| CONVERTING FROM STRING TO INTEGER                                |
//+------------------------------------------------------------------+ 
long SI(string aValue)
  {
   return(StringToInteger(aValue));
  }
//+------------------------------------------------------------------+ 
//| CONVERTING FROM STRING TO DOUBLE                                 |
//+------------------------------------------------------------------+ 
double SD(string aValue)
  {
   return(StringToDouble(aValue));
  }
//+------------------------------------------------------------------+ 
//| NORMALIZATION WITH TWO DIGITS                                    |
//+------------------------------------------------------------------+ 
double ND2(double aValue)
  {
   return(NormalizeDouble(aValue,2));
  }
//+------------------------------------------------------------------+ 
//| NORMALIZATION WITH THE NUMBER OF DIGITS EQUAL TO "DIGITS"        |
//+------------------------------------------------------------------+ 
double ND_dgt(double aValue,int digit)
  {
   return(NormalizeDouble(aValue,digit));
  }
//+------------------------------------------------------------------+ 
//| CORRECTING THE VALUE IN TERMS OF THE NUMBER OF DIGITS IN THE PRICE|
//| MULTIPLICATION                                                   |
//+------------------------------------------------------------------+ 
//| [] - int value                                                   |
//+------------------------------------------------------------------+ 
int vDgtMlt(int value)
  {
   if(SS.dgt==3 || SS.dgt==5) { return(value*=10); } else { return(value); }
  }
//+------------------------------------------------------------------+ 
//| CORRECTING THE VALUE IN TERMS OF THE NUMBER OF DIGITS IN THE PRICE|
//| MULTIPLICATION                                                   |
//+------------------------------------------------------------------+ 
//| [] - double value                                                |
//+------------------------------------------------------------------+ 
double vDgtMlt(double value)
  {
   if(SS.dgt==3 || SS.dgt==5) { return(value*=10); } else { return(value); }
  }
//+------------------------------------------------------------------+ 
//| RETURNING THE FLAG FOR TESTING                                   |
//+------------------------------------------------------------------+ 
bool Testing()
  {
   return(MQL5InfoInteger(MQL5_TESTING));
  }
//+------------------------------------------------------------------+ 
//| RETURNING THE FLAG FOR OPTIMIZATION                              |
//+------------------------------------------------------------------+ 
bool Optimization()
  {
   return(MQL5InfoInteger(MQL5_OPTIMIZATION));
  }
//+------------------------------------------------------------------+ 
//| RETURNING THE FLAG FOR VISUAL TESTING MODE                       |
//+------------------------------------------------------------------+ 
bool VisualMode()
  {
   return(MQL5InfoInteger(MQL5_VISUAL_MODE));
  }
//+------------------------------------------------------------------+ 
//| RETURNING THE FLAG FOR THE REAL TIME MODE OUTSIDE OF THE TEST    |
//+------------------------------------------------------------------+ 
bool NotTest()
  {
   if(!Testing() && !Optimization() && !VisualMode()) { return(true); } else { return(false); }
  }
//+------------------------------------------------------------------+ 
