//+------------------------------------------------------------------+ 
//|                                                 CREATE_PANEL.mqh |
//+------------------------------------------------------------------+ 
int
width_chart=0,// Chart width
height_chart=0; // Chart height
//---
int font_sz=8;
string bsc_fnt="Calibri";
color fnt_clr=clrWhite; // Main font color
//+------------------------------------------------------------------+ 
//| TABLE OF RECORDS                                                 |
//|------------------------------------------------------------------+
void SetInfoPanel()
  {
   if(InfoPanel)
     {
      if(VisualMode() || NotTest())
        {
         int
         fln=0,  // First line
         hln=12; // Line height
         int x0101=100,x0102=10;
         //---
         int
         anchor=ANCHOR_RIGHT_UPPER,
         corner=CORNER_RIGHT_UPPER;
         //---        
         int yV1=0,xV1=125,xV2=10;
         //---
         if(NotTest()) { yV1=18; fln=32; }
         if(VisualMode()) { yV1=1; fln=16; }
         //---
         CreateEdit(0,0,"FonIP","",corner,"Arial",8,clrDimGray,273,80,274,yV1,0,C'15,15,15',1);
         //---
         CreateEdit(0,0,"HeaderIP","EXPERT PARAMETERS",corner,bsc_fnt,8,clrBlack,273,15,274,yV1,2,clrGainsboro,1);
         //---
         CreateLabel(0,0,arr_ip[0],arr_objip[0][0],anchor,corner,bsc_fnt,font_sz,clrWhiteSmoke,x0101,fln,0);
         CreateLabel(0,0,arr_ip[1],""+IS(gPeriod_Ind)+"",anchor,corner,bsc_fnt,font_sz,clrWhiteSmoke,x0102,fln,0);
         //---
         CreateLabel(0,0,arr_ip[2],arr_objip[1][0],anchor,corner,bsc_fnt,font_sz,nmClrTrueFalse((int)gTakeProfit),x0101,fln+hln,0);
         CreateLabel(0,0,arr_ip[3],StrTPSL((int)gTakeProfit),anchor,corner,bsc_fnt,font_sz,ClrTrueFalse((int)gTakeProfit),x0102,fln+hln,0);
         //---
         CreateLabel(0,0,arr_ip[4],arr_objip[2][0],anchor,corner,bsc_fnt,font_sz,nmClrTrueFalse((int)gStopLoss),x0101,fln+hln*2,0);
         CreateLabel(0,0,arr_ip[5],StrTPSL((int)gStopLoss),anchor,corner,bsc_fnt,font_sz,ClrTrueFalse((int)gStopLoss),x0102,fln+hln*2,0);
         //---
         CreateLabel(0,0,arr_ip[6],arr_objip[3][0],anchor,corner,bsc_fnt,font_sz,clrWhiteSmoke,x0101,fln+hln*3,0);
         CreateLabel(0,0,arr_ip[7],StrReversePosition(gReverse),anchor,corner,bsc_fnt,font_sz,ClrTrueFalse(gReverse),x0102,fln+hln*3,0);
         //---
         CreateLabel(0,0,arr_ip[8],arr_objip[4][0],anchor,corner,bsc_fnt,font_sz,clrWhiteSmoke,x0101,fln+hln*4,0);
         CreateLabel(0,0,arr_ip[9],DS2(gLot),anchor,corner,bsc_fnt,font_sz,clrWhiteSmoke,x0102,fln+hln*4,0);
         //---
         ChartRedraw();
        }
     }
   else { DeleteAllExpertObjects(); }
  }
//+------------------------------------------------------------------+ 
//| DELETING ALL OBJECTS CREATED BY THE EXPERT ADVISOR               |
//+------------------------------------------------------------------+ 
void DeleteAllExpertObjects()
  {
   DeleteInfoPanel(); // Delete the infor panel
   DelDialogWindow(lenmObj); // Delete the dialog window
  }
//+------------------------------------------------------------------+ 
//| DELETING THE INFO PANEL                                          |
//+------------------------------------------------------------------+ 
void DeleteInfoPanel()
  {
   DelObjbyName("FonIP");
   DelObjbyName("HeaderIP");
//---
   for(int i=0; i<10; i++)
     { DelObjbyName(arr_ip[i]); }
//---
   ChartRedraw();
  }
//+------------------------------------------------------------------+ 
//| DELETING OBJECTS BY NAME                                         |
//+------------------------------------------------------------------+ 
int DelObjbyName(string Name)
  {
   int nm_obj=0;
   bool res=false;
//---
// Find the object by name
   nm_obj=ObjectFind(ChartID(),Name);
//---
   if(nm_obj>=0) // If the object is found
     {
      res=ObjectDelete(ChartID(),Name); // Delete
      //---
      if(!res)
        { Print("Error while deleting the object: ("+IS(Error())+"): "+ErrorDesc(Error())+""); return(false); }
     }
//---
   return(res);
  }
//+------------------------------------------------------------------+ 
//| CREATING THE LABEL OBJECT                                        |
//+------------------------------------------------------------------+ 
void CreateLabel(long   chrt_id,   // chart id
                 int    nmb_wnd,   // window id
                 string lable_nm,  // object name
                 string rename,    // displayed name
                 long   anchor,    // anchor point
                 long   corner,    // anchor corner
                 string font_bsc,  // font
                 int    font_size, // font size
                 color  font_clr,  // font color
                 int    x_dist,    // coordinate along the X-axis
                 int    y_dist,    // coordinate along the Y-axis
                 long   zorder)    // Z order
  {
   if(ObjectCreate(chrt_id,lable_nm,OBJ_LABEL,nmb_wnd,0,0)) // create the object
     {
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TEXT,rename);          // set the name
      ObjectSetString(chrt_id,lable_nm,OBJPROP_FONT,font_bsc);        // set the font
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_COLOR,font_clr);      // set the font color
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ANCHOR,anchor);       // set the anchor point
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_CORNER,corner);       // set the anchor corner
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_FONTSIZE,font_size);  // set the font size
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_XDISTANCE,x_dist);    // set the X-coordinate
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_YDISTANCE,y_dist);    // set the Y-coordinate
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_SELECTABLE,false);    // cannot select the object if FALSE
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ZORDER,zorder);       // Higher/lower Z order
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TOOLTIP,"\n");         // no tooltip if "\n"
     }
  }
//+------------------------------------------------------------------+ 
//| CREATING THE EDIT OBJECT                                         |
//+------------------------------------------------------------------+ 
void CreateEdit(long   chrt_id,   // chart id
                int    nmb_win,   // (sub)window number
                string lable_nm,  // object name
                string text,      // displayed text
                long   corner,    // anchor corner
                string font_bsc,  // font
                int    font_size, // font size
                color  font_clr,  // font color
                int    xsize,     // width
                int    ysize,     // height
                int    x_dist,    // coordinate along the X-axis
                int    y_dist,    // coordinate along the Y-axis
                long   zorder,    // Z order
                color  clr,       // background color
                bool   flgORead)  // Read Only flag
  {
   if(ObjectCreate(chrt_id,lable_nm,OBJ_EDIT,nmb_win,0,0)) // create the object
     {
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TEXT,text);            // set the name
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_CORNER,corner);       // set the anchor corner
      ObjectSetString(chrt_id,lable_nm,OBJPROP_FONT,font_bsc);        // set the font
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_FONTSIZE,font_size);  // set the font size
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_COLOR,font_clr);      // font color
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_BGCOLOR,clr);         // background color
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_XSIZE,xsize);         // width
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_YSIZE,ysize);         // height
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_XDISTANCE,x_dist);    // set the X-coordinate
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_YDISTANCE,y_dist);    // set the Y-coordinate
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_SELECTABLE,false);    // cannot select the object if FALSE
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ZORDER,zorder);       // Higher/lower Z order
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_READONLY,flgORead);   // Read Only
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ALIGN,ALIGN_LEFT);    // Align left
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TOOLTIP,"\n");         // no tooltip if "\n"
     }
  }
//+------------------------------------------------------------------+ 
//| CREATING THE BMP_LABEL OBJECT                                    |
//+------------------------------------------------------------------+ 
void CreateBMPLabel(long   chrt_id,       // chart id
                    int    nmb_wnd,       // subwindow id
                    string bmp_nm,        // object name
                    string bmp_path_on,   // object path ON
                    string bmp_path_off,  // object path OFF
                    long   corner,        // anchor corner
                    long   anchor,        // anchor corner
                    int    x_dist,        // coordinate along the X-axis
                    int    y_dist,        // coordinate along the Y-axis
                    bool   stateBMP,      // state
                    long   zorder,        // Z order
                    string tooltip)       // tooltip
  {
   if(ObjectCreate(chrt_id,bmp_nm,OBJ_BITMAP_LABEL,nmb_wnd,0,0)) // create the object
     {
      ObjectSetString(chrt_id,bmp_nm,OBJPROP_BMPFILE,0,bmp_path_on);    // BMP file in the ON state
      ObjectSetString(chrt_id,bmp_nm,OBJPROP_BMPFILE,1,bmp_path_off);   // BMP file in the OFF state
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_STATE,stateBMP);          // initial state
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_CORNER,corner);           // set the anchor corner
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_ANCHOR,anchor);           // set the anchor corner
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_XDISTANCE,x_dist);        // set the X-coordinate
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_YDISTANCE,y_dist);        // set the Y-coordinate
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_SELECTABLE,false);        // cannot select the object if FALSE
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_ZORDER,zorder);           // Z order
      ObjectSetString(chrt_id,bmp_nm,OBJPROP_TOOLTIP,tooltip);          // no tooltip if "\n"
      ObjectSetInteger(chrt_id,bmp_nm,OBJPROP_COLOR,clrNONE);           // no border color of the object
     }
  }
//+------------------------------------------------------------------+ 
//| CREATING THE BUTTON OBJECT                                       |
//+------------------------------------------------------------------+ 
void CreateButton(long   chrt_id,   // chart id
                  int    nmb_win,   // window number
                  string lable_nm,  // object name
                  string rename,    // displayed name
                  long   anchor,    // anchor point
                  long   corner,    // anchor corner
                  string font_bsc,  // font
                  int    font_size, // font size
                  color  font_clr,  // font color
                  color  bg_color,  // background color
                  color  brd_color, // border color
                  int    xsize,     // width
                  int    ysize,     // height
                  int    x_dist,    // coordinate along the X-axis
                  int    y_dist,    // coordinate along the Y-axis
                  long   zorder)    // Z order
  {
   if(ObjectCreate(chrt_id,lable_nm,OBJ_BUTTON,nmb_win,0,0)) // create the object
     {
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TEXT,rename);             // set the name
      ObjectSetString(chrt_id,lable_nm,OBJPROP_FONT,font_bsc);           // set the font
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_COLOR,font_clr);         // set the font color
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_BGCOLOR,bg_color);       // set the background color
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_BORDER_COLOR,brd_color); // set the border color
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ANCHOR,anchor);          // set the anchor point
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_CORNER,corner);          // set the anchor corner
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_FONTSIZE,font_size);     // set the font size
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_XSIZE,xsize);            // set the X width
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_YSIZE,ysize);            // set the Y height
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_XDISTANCE,x_dist);       // set the X-coordinate
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_YDISTANCE,y_dist);       // set the Y-coordinate
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_SELECTABLE,false);       // cannot select the object if FALSE
      ObjectSetInteger(chrt_id,lable_nm,OBJPROP_ZORDER,zorder);         // Higher/lower Z order
      ObjectSetString(chrt_id,lable_nm,OBJPROP_TOOLTIP,"\n");            // no tooltip if "\n"
     }
  }
//+------------------------------------------------------------------+ 
